#![allow(deprecated)]
use std::fmt;
use std::str;
/// Content-Type for webhook requests
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum WebhookContentType {
    /// application/json
    #[serde(rename = "APPLICATION_JSON")]
    ApplicationJson,
    /// application/x-www-form-urlencoded
    #[serde(rename = "APPLICATION_X_WWW_FORM_URLENCODED")]
    ApplicationXWwwFormUrlencoded,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl WebhookContentType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            WebhookContentType::ApplicationJson => "APPLICATION_JSON",
            WebhookContentType::ApplicationXWwwFormUrlencoded => {
                "APPLICATION_X_WWW_FORM_URLENCODED"
            }
            WebhookContentType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for WebhookContentType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for WebhookContentType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for WebhookContentType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<WebhookContentType, conjure_object::plain::ParseEnumError> {
        match v {
            "APPLICATION_JSON" => Ok(WebhookContentType::ApplicationJson),
            "APPLICATION_X_WWW_FORM_URLENCODED" => {
                Ok(WebhookContentType::ApplicationXWwwFormUrlencoded)
            }
            v => v.parse().map(|v| WebhookContentType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for WebhookContentType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<WebhookContentType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the WebhookContentType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
